Index: irmp.c
===================================================================
--- irmp.c	(Revision 191)
+++ irmp.c	(Arbeitskopie)
@@ -2900,41 +2926,41 @@ irmp_store_bit (uint_fast8_t value)
 #endif
 
 #if IRMP_SUPPORT_MITSU_HEAVY_PROTOCOL == 1
-    if (irmp_param.protocol == IRMP_MITSU_HEAVY_PROTOCOL)                           // squeeze 64 bits into 16 bits:
+    if (ir->param.protocol == IRMP_MITSU_HEAVY_PROTOCOL)                           // squeeze 64 bits into 16 bits:
     {
-        if (irmp_bit == 72 )
-        {                                                                           // irmp_tmp_address, irmp_tmp_command received: check parity & compress
+        if (ir->bit == 72)
+        {                                                                           // ir->tmp_address, ir->tmp_command received: check parity & compress
             mitsu_parity = PARITY_CHECK_OK;
 
-            check = irmp_tmp_address >> 8;                                          // inverted upper byte == lower byte?
+            check = ir->tmp_address >> 8;                                          // inverted upper byte == lower byte?
             check = ~ check;
 
-            if (check == (irmp_tmp_address & 0xFF))
+            if (check == (ir->tmp_address & 0xFF))

             {                                                                       // ok:
-                irmp_tmp_address <<= 8;                                             // throw away upper byte
+                ir->tmp_address <<= 8;                                             // throw away upper byte
             }
             else
             {
                 mitsu_parity = PARITY_CHECK_FAILED;
             }
 
-            check = irmp_tmp_command >> 8;                                          // inverted upper byte == lower byte?
+            check = ir->tmp_command >> 8;                                          // inverted upper byte == lower byte?
             check = ~ check;
-            if (check == (irmp_tmp_command & 0xFF))
+            if (check == (ir->tmp_command & 0xFF))
             {                                                                       // ok:  pack together
-                irmp_tmp_address |= irmp_tmp_command & 0xFF;                        // byte 1, byte2 in irmp_tmp_address, irmp_tmp_command can be used for byte 3
+                ir->tmp_address |= ir->tmp_command & 0xFF;                        // byte 1, byte2 in ir->tmp_address, ir->tmp_command can be used for byte 3
             }
             else
             {
                 mitsu_parity = PARITY_CHECK_FAILED;
             }
-            irmp_tmp_command = 0;
+            ir->tmp_command = 0;
         }
 
-        if (irmp_bit >= 72 )
-        {                                                                           // receive 3. word in irmp_tmp_command
-            irmp_tmp_command <<= 1;
-            irmp_tmp_command |= value;
+        if (ir->bit >= 72)
+        {                                                                           // receive 3. word in ir->tmp_command
+            ir->tmp_command <<= 1;
+            ir->tmp_command |= value;
         }
     }
     else
@@ -2943,14 +2969,14 @@ irmp_store_bit (uint_fast8_t value)
         ;
     }
 
-    irmp_bit++;
+    ir->bit++;
 }
 
-/*---------------------------------------------------------------------------------------------------------------------------------------------------
+/*------------------------------------------------------------------------------
  *  store bit
  *  @details  store bit in temp address or temp command
  *  @param    value to store: 0 or 1
- *---------------------------------------------------------------------------------------------------------------------------------------------------
+ *------------------------------------------------------------------------------
  */
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)
 static void
@@ -2958,22 +2984,22 @@ irmp_store_bit2 (uint_fast8_t value)
 {
     uint_fast8_t irmp_bit2;
 
-    if (irmp_param.protocol)
+    if (irmp.param.protocol)
     {
-        irmp_bit2 = irmp_bit - 2;
+        irmp_bit2 = irmp.bit - 2;
     }
     else
     {
-        irmp_bit2 = irmp_bit - 1;
+        irmp_bit2 = irmp.bit - 1;
     }
 
-    if (irmp_bit2 >= irmp_param2.address_offset && irmp_bit2 < irmp_param2.address_end)
+    if (irmp_bit2 >= irmp.param2.address_offset && irmp_bit2 < irmp.param2.address_end)
     {
-        irmp_tmp_address2 |= (((uint_fast16_t) (value)) << (irmp_bit2 - irmp_param2.address_offset));   // CV wants cast
+        irmp.tmp_address2 |= (((uint_fast16_t) (value)) << (irmp_bit2 - irmp.param2.address_offset));   // CV wants cast
     }
-    else if (irmp_bit2 >= irmp_param2.command_offset && irmp_bit2 < irmp_param2.command_end)
+    else if (irmp_bit2 >= irmp.param2.command_offset && irmp_bit2 < irmp.param2.command_end)
     {
-        irmp_tmp_command2 |= (((uint_fast16_t) (value)) << (irmp_bit2 - irmp_param2.command_offset));   // CV wants cast
+        irmp.tmp_command2 |= (((uint_fast16_t) (value)) << (irmp_bit2 - irmp.param2.command_offset));   // CV wants cast
     }
 }
 #endif // IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)
@@ -2986,19 +3012,15 @@ irmp_store_bit2 (uint_fast8_t value)
 uint_fast8_t
 irmp_ISR (void)
 {
-    static uint_fast8_t     irmp_start_bit_detected;                                // flag: start bit detected
-    static uint_fast8_t     wait_for_space;                                         // flag: wait for data bit space
-    static uint_fast8_t     wait_for_start_space;                                   // flag: wait for start bit space
-    static uint_fast8_t     irmp_pulse_time;                                        // count bit time for pulse
-    static PAUSE_LEN        irmp_pause_time;                                        // count bit time for pause
+    irmp_t *ir = &irmp;
+    __asm ("" : "+r" (ir));
+
     static uint_fast16_t    last_irmp_address = 0xFFFF;                             // save last irmp address to recognize key repetition
 #if IRMP_32_BIT == 1
     static uint_fast32_t    last_irmp_command = 0xFFFFFFFF;                         // save last irmp command to recognize key repetition
 #else
     static uint_fast16_t    last_irmp_command = 0xFFFF;                             // save last irmp command to recognize key repetition
 #endif
-    static uint_fast16_t    key_repetition_len;                                     // SIRCS repeats frame 2-5 times with 45 ms pause
-    static uint_fast8_t     repetition_frame_number;
 #if IRMP_SUPPORT_DENON_PROTOCOL == 1
     static uint_fast16_t    last_irmp_denon_command;                                // save last irmp command to recognize DENON frame repetition
     static uint_fast16_t    denon_repetition_len = 0xFFFF;                          // denon repetition len of 2nd auto generated frame
@@ -3023,12 +3045,13 @@ irmp_ISR (void)
     static uint_fast8_t     last_irmp_start_bit_detected = 0xFF;
     static uint_fast8_t     last_irmp_pulse_time = 0xFF;
 
-    if (last_irmp_start_bit_detected != irmp_start_bit_detected || last_irmp_pulse_time != irmp_pulse_time)
+    if (last_irmp_start_bit_detected != ir->isr.start_bit_detected
+        || last_irmp_pulse_time != ir->isr.pulse_time)
     {
-        last_irmp_start_bit_detected    = irmp_start_bit_detected;
-        last_irmp_pulse_time            = irmp_pulse_time;
+        last_irmp_start_bit_detected    = ir->isr.start_bit_detected;
+        last_irmp_pulse_time            = ir->isr.pulse_time;
 
-        printf ("%d %d %d\n", time_counter, irmp_start_bit_detected, irmp_pulse_time);
+        printf ("%d %d %d\n", time_counter, ir->isr.start_bit_detected, ir->isr.pulse_time);
     }
 #endif // 0
 
@@ -3059,56 +3082,56 @@ irmp_ISR (void)
 
     irmp_log(irmp_input);                                                       // log ir signal, if IRMP_LOGGING defined
 
-    if (! irmp_ir_detected)                                                     // ir code already detected?
+    if (! ir->ir_detected)                                                     // ir code already detected?
     {                                                                           // no...
-        if (! irmp_start_bit_detected)                                          // start bit detected?
+        if (! ir->isr.start_bit_detected)                                          // start bit detected?
         {                                                                       // no...
             if (! irmp_input)                                                   // receiving burst?
             {                                                                   // yes...
 //              irmp_busy_flag = TRUE;
 #ifdef ANALYZE
-                if (! irmp_pulse_time)
+                if (! ir->isr.pulse_time)
                 {
                     ANALYZE_PRINTF("%8.3fms [starting pulse]\n", (double) (time_counter * 1000) / F_INTERRUPTS);
                 }
 #endif // ANALYZE
-                irmp_pulse_time++;                                              // increment counter
+                ir->isr.pulse_time++;                                              // increment counter
             }
             else
             {                                                                   // no...
-                if (irmp_pulse_time)                                            // it's dark....
+                if (ir->isr.pulse_time)                                            // it's dark....
                 {                                                               // set flags for counting the time of darkness...
-                    irmp_start_bit_detected = 1;
-                    wait_for_start_space    = 1;
-                    wait_for_space          = 0;
-                    irmp_tmp_command        = 0;
-                    irmp_tmp_address        = 0;
+                    ir->isr.start_bit_detected = 1;
+                    ir->isr.wait_for_start_space    = 1;
+                    ir->isr.wait_for_space          = 0;
+                    ir->tmp_command        = 0;
+                    ir->tmp_address        = 0;
 #if IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1
                     genre2                  = 0;
 #endif
 #if IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
-                    irmp_tmp_id = 0;
+                    ir->tmp_id = 0;
 #endif
 
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1) || IRMP_SUPPORT_NEC42_PROTOCOL == 1
-                    irmp_tmp_command2       = 0;
-                    irmp_tmp_address2       = 0;
+                    ir->tmp_command2       = 0;
+                    ir->tmp_address2       = 0;
 #endif
 #if IRMP_SUPPORT_LGAIR_PROTOCOL == 1
-                    irmp_lgair_command      = 0;
-                    irmp_lgair_address      = 0;
+                    ir->lgair_command      = 0;
+                    ir->lgair_address      = 0;
 #endif
-                    irmp_bit                = 0xff;
-                    irmp_pause_time         = 1;                                // 1st pause: set to 1, not to 0!
+                    ir->bit                = 0xff;
+                    ir->isr.pause_time         = 1;                                // 1st pause: set to 1, not to 0!
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 || IRMP_SUPPORT_S100_PROTOCOL == 1
                     rc5_cmd_bit6            = 0;                                // fm 2010-03-07: bugfix: reset it after incomplete RC5 frame!
 #endif
                 }
                 else
                 {
-                    if (key_repetition_len < 0xFFFF)                            // avoid overflow of counter
+                    if (ir->isr.key_repetition_len < 0xFFFF)                            // avoid overflow of counter
                     {
-                        key_repetition_len++;
+                        ir->isr.key_repetition_len++;
 
 #if IRMP_SUPPORT_DENON_PROTOCOL == 1
                         if (denon_repetition_len < 0xFFFF)                      // avoid overflow of counter
@@ -3132,21 +3155,21 @@ irmp_ISR (void)
         }
         else
         {
-            if (wait_for_start_space)                                           // we have received start bit...
+            if (ir->isr.wait_for_start_space)                                           // we have received start bit...
             {                                                                   // ...and are counting the time of darkness
                 if (irmp_input)                                                 // still dark?
                 {                                                               // yes
-                    irmp_pause_time++;                                          // increment counter
+                    ir->isr.pause_time++;                                          // increment counter
 
 #if IRMP_SUPPORT_NIKON_PROTOCOL == 1
-                    if (((irmp_pulse_time < NIKON_START_BIT_PULSE_LEN_MIN || irmp_pulse_time > NIKON_START_BIT_PULSE_LEN_MAX) && irmp_pause_time > IRMP_TIMEOUT_LEN) ||
-                         irmp_pause_time > IRMP_TIMEOUT_NIKON_LEN)
+                    if (((ir->isr.pulse_time < NIKON_START_BIT_PULSE_LEN_MIN || ir->isr.pulse_time > NIKON_START_BIT_PULSE_LEN_MAX) && ir->isr.pause_time > IRMP_TIMEOUT_LEN) ||
+                         ir->isr.pause_time > IRMP_TIMEOUT_NIKON_LEN)
 #else
-                    if (irmp_pause_time > IRMP_TIMEOUT_LEN)                     // timeout?
+                    if (ir->isr.pause_time > IRMP_TIMEOUT_LEN)                     // timeout?
 #endif
                     {                                                           // yes...
 #if IRMP_SUPPORT_JVC_PROTOCOL == 1
-                        if (irmp_protocol == IRMP_JVC_PROTOCOL)                 // don't show eror if JVC protocol, irmp_pulse_time has been set below!
+                        if (ir->protocol == IRMP_JVC_PROTOCOL)                 // don't show eror if JVC protocol, ir->isr.pulse_time has been set below!
                         {
                             ;
                         }
@@ -3154,14 +3177,14 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_JVC_PROTOCOL == 1
                         {
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("%8.3fms error 1: pause after start bit pulse %d too long: %d\n", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_pulse_time, irmp_pause_time);
+                            ANALYZE_PRINTF ("%8.3fms error 1: pause after start bit pulse %d too long: %d\n", (double) (time_counter * 1000) / F_INTERRUPTS, ir->isr.pulse_time, ir->isr.pause_time);
                             ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
                         }
 
-                        irmp_start_bit_detected = 0;                            // reset flags, let's wait for another start bit
-                        irmp_pulse_time         = 0;
-                        irmp_pause_time         = 0;
+                        ir->isr.start_bit_detected = 0;                            // reset flags, let's wait for another start bit
+                        ir->isr.pulse_time         = 0;
+                        ir->isr.pause_time         = 0;
                     }
                 }
                 else
@@ -3170,16 +3193,16 @@ irmp_ISR (void)
                     irmp_param_p = (IRMP_PARAMETER *) 0;
 
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)
-                    irmp_param2.protocol = 0;
+                    ir->param2.protocol = 0;
 #endif
 
 #ifdef ANALYZE
-                    ANALYZE_PRINTF ("%8.3fms [start-bit: pulse = %2d, pause = %2d]\n", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_pulse_time, irmp_pause_time);
+                    ANALYZE_PRINTF ("%8.3fms [start-bit: pulse = %2d, pause = %2d]\n", (double) (time_counter * 1000) / F_INTERRUPTS, ir->isr.pulse_time, ir->isr.pause_time);
 #endif // ANALYZE
 
 #if IRMP_SUPPORT_SIRCS_PROTOCOL == 1
-                    if (irmp_pulse_time >= SIRCS_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= SIRCS_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= SIRCS_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= SIRCS_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= SIRCS_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= SIRCS_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= SIRCS_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= SIRCS_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's SIRCS
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = SIRCS, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3192,9 +3215,9 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_SIRCS_PROTOCOL == 1
 
 #if IRMP_SUPPORT_JVC_PROTOCOL == 1
-                    if (irmp_protocol == IRMP_JVC_PROTOCOL &&                                                       // last protocol was JVC, awaiting repeat frame
-                        irmp_pulse_time >= JVC_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= JVC_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= JVC_REPEAT_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= JVC_REPEAT_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->protocol == IRMP_JVC_PROTOCOL &&                                                       // last protocol was JVC, awaiting repeat frame
+                        ir->isr.pulse_time >= JVC_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= JVC_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= JVC_REPEAT_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= JVC_REPEAT_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = NEC or JVC (type 1) repeat frame, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3207,8 +3230,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_JVC_PROTOCOL == 1
 
 #if IRMP_SUPPORT_NEC_PROTOCOL == 1
-                    if (irmp_pulse_time >= NEC_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= NEC_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= NEC_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= NEC_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= NEC_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= NEC_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= NEC_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= NEC_START_BIT_PAUSE_LEN_MAX)
                     {
 #if IRMP_SUPPORT_NEC42_PROTOCOL == 1
 #ifdef ANALYZE
@@ -3226,11 +3249,11 @@ irmp_ISR (void)
                         irmp_param_p = (IRMP_PARAMETER *) &nec_param;
 #endif
                     }
-                    else if (irmp_pulse_time >= NEC_START_BIT_PULSE_LEN_MIN        && irmp_pulse_time <= NEC_START_BIT_PULSE_LEN_MAX &&
-                             irmp_pause_time >= NEC_REPEAT_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= NEC_REPEAT_START_BIT_PAUSE_LEN_MAX)
+                    else if (ir->isr.pulse_time >= NEC_START_BIT_PULSE_LEN_MIN        && ir->isr.pulse_time <= NEC_START_BIT_PULSE_LEN_MAX &&
+                             ir->isr.pause_time >= NEC_REPEAT_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= NEC_REPEAT_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's NEC
 #if IRMP_SUPPORT_JVC_PROTOCOL == 1
-                        if (irmp_protocol == IRMP_JVC_PROTOCOL)                 // last protocol was JVC, awaiting repeat frame
+                        if (ir->protocol == IRMP_JVC_PROTOCOL)                 // last protocol was JVC, awaiting repeat frame
                         {                                                       // some jvc remote controls use nec repetition frame for jvc repetition frame
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("protocol = JVC repeat frame type 2, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3254,9 +3277,9 @@ irmp_ISR (void)
                     else
 
 #if IRMP_SUPPORT_JVC_PROTOCOL == 1
-                    if (irmp_protocol == IRMP_JVC_PROTOCOL &&                   // last protocol was JVC, awaiting repeat frame
-                        irmp_pulse_time >= NEC_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= NEC_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= NEC_0_PAUSE_LEN_MIN         && irmp_pause_time <= NEC_0_PAUSE_LEN_MAX)
+                    if (ir->protocol == IRMP_JVC_PROTOCOL &&                   // last protocol was JVC, awaiting repeat frame
+                        ir->isr.pulse_time >= NEC_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= NEC_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= NEC_0_PAUSE_LEN_MIN         && ir->isr.pause_time <= NEC_0_PAUSE_LEN_MAX)
                     {                                                           // it's JVC repetition type 3
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = JVC repeat frame type 3, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3271,8 +3294,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_NEC_PROTOCOL == 1
 
 #if IRMP_SUPPORT_TELEFUNKEN_PROTOCOL == 1
-                    if (irmp_pulse_time >= TELEFUNKEN_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= TELEFUNKEN_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= TELEFUNKEN_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= TELEFUNKEN_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= TELEFUNKEN_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= TELEFUNKEN_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= TELEFUNKEN_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= TELEFUNKEN_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = TELEFUNKEN, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3285,8 +3308,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_TELEFUNKEN_PROTOCOL == 1
 
 #if IRMP_SUPPORT_ROOMBA_PROTOCOL == 1
-                    if (irmp_pulse_time >= ROOMBA_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= ROOMBA_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= ROOMBA_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= ROOMBA_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= ROOMBA_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= ROOMBA_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= ROOMBA_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= ROOMBA_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = ROOMBA, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3299,8 +3322,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_ROOMBA_PROTOCOL == 1
 
 #if IRMP_SUPPORT_ACP24_PROTOCOL == 1
-                    if (irmp_pulse_time >= ACP24_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= ACP24_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= ACP24_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= ACP24_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= ACP24_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= ACP24_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= ACP24_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= ACP24_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = ACP24, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3313,8 +3336,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_ROOMBA_PROTOCOL == 1
 
 #if IRMP_SUPPORT_PENTAX_PROTOCOL == 1
-                    if (irmp_pulse_time >= PENTAX_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= PENTAX_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= PENTAX_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= PENTAX_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= PENTAX_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= PENTAX_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= PENTAX_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= PENTAX_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = PENTAX, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3327,8 +3350,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_PENTAX_PROTOCOL == 1
 
 #if IRMP_SUPPORT_NIKON_PROTOCOL == 1
-                    if (irmp_pulse_time >= NIKON_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= NIKON_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= NIKON_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= NIKON_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= NIKON_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= NIKON_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= NIKON_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= NIKON_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = NIKON, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3341,8 +3364,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_NIKON_PROTOCOL == 1
 
 #if IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
-                    if (irmp_pulse_time >= SAMSUNG_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= SAMSUNG_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= SAMSUNG_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= SAMSUNG_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= SAMSUNG_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= SAMSUNG_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= SAMSUNG_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= SAMSUNG_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's SAMSUNG
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = SAMSUNG, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3355,8 +3378,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
 
 #if IRMP_SUPPORT_SAMSUNGAH_PROTOCOL == 1
-                    if (irmp_pulse_time >= SAMSUNGAH_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= SAMSUNGAH_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= SAMSUNGAH_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= SAMSUNGAH_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= SAMSUNGAH_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= SAMSUNGAH_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= SAMSUNGAH_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= SAMSUNGAH_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's SAMSUNGAH
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = SAMSUNGAH, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3369,8 +3392,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_SAMSUNGAH_PROTOCOL == 1
 
 #if IRMP_SUPPORT_MATSUSHITA_PROTOCOL == 1
-                    if (irmp_pulse_time >= MATSUSHITA_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= MATSUSHITA_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= MATSUSHITA_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= MATSUSHITA_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= MATSUSHITA_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= MATSUSHITA_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= MATSUSHITA_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= MATSUSHITA_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's MATSUSHITA
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = MATSUSHITA, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3383,8 +3406,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_MATSUSHITA_PROTOCOL == 1
 
 #if IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1
-                    if (irmp_pulse_time >= KASEIKYO_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= KASEIKYO_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= KASEIKYO_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= KASEIKYO_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= KASEIKYO_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= KASEIKYO_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= KASEIKYO_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= KASEIKYO_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's KASEIKYO
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = KASEIKYO, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3397,8 +3420,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1
 
 #if IRMP_SUPPORT_PANASONIC_PROTOCOL == 1
-                    if (irmp_pulse_time >= PANASONIC_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= PANASONIC_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= PANASONIC_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= PANASONIC_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= PANASONIC_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= PANASONIC_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= PANASONIC_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= PANASONIC_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's PANASONIC
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = PANASONIC, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3411,8 +3434,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_PANASONIC_PROTOCOL == 1
 
 #if IRMP_SUPPORT_MITSU_HEAVY_PROTOCOL == 1
-                    if (irmp_pulse_time >= MITSU_HEAVY_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= MITSU_HEAVY_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= MITSU_HEAVY_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= MITSU_HEAVY_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= MITSU_HEAVY_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= MITSU_HEAVY_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= MITSU_HEAVY_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= MITSU_HEAVY_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's MITSU_HEAVY
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = MITSU_HEAVY, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3425,8 +3448,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_MITSU_HEAVY_PROTOCOL == 1
 
 #if IRMP_SUPPORT_VINCENT_PROTOCOL == 1
-                    if (irmp_pulse_time >= VINCENT_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= VINCENT_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= VINCENT_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= VINCENT_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= VINCENT_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= VINCENT_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= VINCENT_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= VINCENT_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's VINCENT
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = VINCENT, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
